package cn.gygxzc.tina.config.shiro.common

import java.io.Serializable

/**
 * 权限数据结构
 *
 * 从Resource/Menu抽象
 *
 * @author NorthLan
 * @date 2018/4/29
 * @url https://noahlan.com
 */
open class ZenPermission : Serializable {
    companion object {
        private const val serialVersionUID = 5640224091610186666L
    }

    /**
     * ResourceId
     */
    var id: Long? = null

    /**
     * 权限代码 (前端使用)
     */
    var code: String? = null

    /**
     * 请求地址
     */
    var uri: String? = null

    /**
     * 请求方法
     */
    var method: String? = null

    /**
     * 权限类型
     * 1. 按钮 2.url
     */
    var type: Int? = null

    /**
     * 简短名称
     */
    var name: String? = null

    /**
     * 树ID
     */
    var treeId: Long? = null
}