package com.gxzc.zen.orm.data.authority.visitor

import net.sf.jsqlparser.expression.StringValue
import net.sf.jsqlparser.expression.operators.conditional.AndExpression
import net.sf.jsqlparser.expression.operators.relational.ExpressionList
import net.sf.jsqlparser.expression.operators.relational.InExpression
import net.sf.jsqlparser.schema.Column
import net.sf.jsqlparser.statement.select.PlainSelect
import net.sf.jsqlparser.statement.select.SelectVisitor
import net.sf.jsqlparser.statement.select.SetOperationList
import net.sf.jsqlparser.statement.select.WithItem

/**
 * 数据权限 Select Visitor (处理sql)
 * @author NorthLan
 * @date 2018/7/9
 * @url https://noahlan.com
 */
class DataAuthoritySelectVisitor : SelectVisitor {

    override fun visit(plainSelect: PlainSelect) {
        val inExp = InExpression().apply {
            this.leftExpression = Column("create_by")
            this.rightItemsList = ExpressionList(StringValue("admin"), StringValue("haha"))
        }

        if (plainSelect.where == null) {
            plainSelect.where = inExp
        } else {
            plainSelect.where = AndExpression(plainSelect.where, inExp)
        }
    }

    override fun visit(setOpList: SetOperationList) {
        setOpList.selects.forEach {
            it.accept(DataAuthoritySelectVisitor())
        }
    }

    override fun visit(withItem: WithItem) {
        withItem.selectBody.accept(DataAuthoritySelectVisitor())
    }
}