package com.gxzc.zen

import com.fasterxml.jackson.databind.ObjectMapper
import com.gxzc.zen.common.util.TreeUtil
import com.gxzc.zen.common.util.common.TreeNode
import org.junit.Test

/**
 *
 * @author NorthLan
 * @date 2018/4/28
 * @url https://noahlan.com
 */
class TestTree {

    private fun buildData(): MutableList<TreeNode> {
        return mutableListOf<TreeNode>().apply {
            add(TreeNode().apply {
                id = 1
                parentId = 0
            })
            add(TreeNode().apply {
                id = 2
                parentId = 1
            })
            add(TreeNode().apply {
                id = 3
                parentId = 1
            })
            add(TreeNode().apply {
                id = 4
                parentId = 2
            })
            add(TreeNode().apply {
                id = 5
                parentId = 4
            })
            add(TreeNode().apply {
                id = 6
                parentId = 4
            })
            add(TreeNode().apply {
                id = 7
                parentId = 4
            })
            add(TreeNode().apply {
                id = 8
                parentId = 4
            })
            add(TreeNode().apply {
                id = 9
                parentId = 4
            })
            add(TreeNode().apply {
                id = 10
                parentId = 4
            })
        }
    }

    @Test
    fun testTree() {
        val data = buildData()

        // 时间
        val now = System.currentTimeMillis()

        val tree = TreeUtil.build(data, 0)

        val n = System.currentTimeMillis()
        println("循环时间: ${n - now}")

        val tree2 = TreeUtil.buildByRecursive(data, 0)

        println("递归时间: ${System.currentTimeMillis() - n}")

        println(ObjectMapper().writeValueAsString(tree))

        println(ObjectMapper().writeValueAsString(tree2))

        // 数据量小的情况 循环时间>递归时间
    }

    @Test
    fun testTreeFind() {
        val data = buildData()
        val tree = TreeUtil.buildByRecursive(data, 0)

        println(ObjectMapper().writeValueAsString(tree))


        var now = System.currentTimeMillis()
        val find = TreeUtil.findBFS(tree) {
            it.id == 4L && it.parentId == 2L
        }

        println("BFS: ${System.currentTimeMillis() - now}")

        println(ObjectMapper().writeValueAsString(find))

        now = System.currentTimeMillis()
        val find2 = TreeUtil.findDFS(tree) {
            it.id == 4L && it.parentId == 2L
        }

        println("DFS: ${System.currentTimeMillis() - now}")


        println(ObjectMapper().writeValueAsString(find2))
    }
}